import crisprbact


def test_on_target_predict_empty():
    # Empty sequence
    predicted_target = crisprbact.on_target_predict("")
    assert len(predicted_target) == 0, "the list is non empty"


def test_on_target_predict_size_guide():
    size_guide = 20
    predicted_targets = crisprbact.on_target_predict(
        """ TGCCTGTTTACGCGCCGATTGTTGCG
        AGATTTGGACGGACGTTGACGGGG
        TCTATACCTGCGACCCGCGTCAGG
        TGCCCGATGCGAGGTTGTTGAAGT
        CGATGTCCTACCAGGAAGCGATGG
        AGCTTTCCTACTTCGGCG"""
    )
    guides = (predicted_target["guide"] for predicted_target in predicted_targets)
    for guide in guides:
        assert len(guide) == size_guide, (
            "the guide do not have a length of " + size_guide
        )
    pams = (
        (predicted_target["pam"], predicted_target["start"])
        for predicted_target in predicted_targets
    )
    for pam in pams:
        (pam_val, start_val) = pam
        assert (
            start_val - pam_val == 2
        ), "the difference between start and pam position is different than 2"
